/*
	Author	: Sreedhar Sivakumaran
	Purpose	: Header file for name server interaction 
	Notes	:

	Message format: 

	Portid	- nethostid:portid	
	Header 	- opcode

	DTM to nameserver

	Send message length.

	Mreg  	  - Header refname portname Portid
	Mackroute - Header refname portname 

	Nameserver to DTM

	Send message length.

	Mroute 	- Header delcount addcount Portid1 Portid2 ...

	Ports to be deleted should be before ports to be added.

	Nethostid is in dotted decimal notation of internet.
*/

#define	MREGID		0
#define	MREG		"%d %s %s %s:%d"
#define	MROUTEID	1
#define	MROUTE		"%d %d %d"		/*  %s:%d  %s:%d .... */
#define	MACKROUTEID	2
#define	MACKROUTE	"%d %s %s"	

/*	Names of nameserver, refname environment variables	*/
 
#define	DTM_NAMESERVER	"_DTM_NAMESERVER"
#define	DTM_REFNAME	"_DTM_REFNAME"	
